package classes;

import java.util.ArrayList;

public class HolonObject extends CpsObject {

	/* Array of all consumers */
	private ArrayList<HolonElement> elements;
	/* Total of consumption */
	private float currentEnergy;
	/**
	 * State of the building: 0 = fully supplied (currentEnergy == 0) 1 = not
	 * enough energy (currentEnergy > 0) 2 = oversupplied (currentEnergy < 0)
	 */
	int state;

	/**
	 * Constructor Set by default the name of the object equals to the category
	 * name, until the user changes it.
	 */
	public HolonObject(String ObjName) {
		super(ObjName);
		elements = new ArrayList<HolonElement>();
	}

	public HolonObject(String ObjName, String obj) {
		super(ObjName);
		super.name = obj;
		elements = new ArrayList<HolonElement>();
	}

	public HolonObject(CpsObject obj) {
		super(obj);
		elements = new ArrayList<HolonElement>();
		this.elements = ((HolonObject)obj).getElements();

	}



	
	/**
	 * @return the elements
	 */
	public ArrayList<HolonElement> getElements() {
		return elements;
	}

	/**
	 * @param elements the elements to set
	 */
	public void setElements(ArrayList<HolonElement> elements) {
		this.elements = elements;
	}

	/**
	 * @return the currentEnergy
	 */
	public float getCurrentEnergy() {
		return currentEnergy;
	}

	/**
	 * @param currentEnergy the currentEnergy to set
	 */
	public void setCurrentEnergy(float currentEnergy) {
		this.currentEnergy = currentEnergy;
	}

	/**
	 * deletes Element
	 * @param idx
	 */
	public void deleteElement(int idx) {
		elements.remove(idx);
	}

	public float calculateCurrentEnergy() {
		return currentEnergy;
	}

	

	/**
	 * String of all consumers in this HolonObject
	 * 
	 * @return all the names of this HolonObject separated by "," each object
	 */
	public String toStringElements() {
		String objString = "";
		for (HolonElement e : elements) {
			if (objString == "") {
				objString = e.getEleName();
			} else {
				objString = objString + ", " + e.getEleName();
			}

		}
		return objString;
	}
}